/*
 *  CProcessFlash.h
 *  CDPFMate3.0
 *
 *  Created by Xu Huajun on 9/14/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include <Carbon/Carbon.h>
#include "CCommUSB.h"
#define		 BYTE	unsigned char
typedef	struct
{
	char			typeName[32];
	UInt8			memsize[4];
	UInt8			devID[4];
	BYTE			eraseCMD;
	BYTE			writeCMD;
	BYTE			readCMD;
	char            data;
	UInt8			iWriteByByte[4];
}FLASH_TYPE_STRUCT;
class CProcessFlash
{
public: 
	CProcessFlash(CCommUSB *m_USBCom);
	unsigned short GetMemSize();
	bool GetLCDParam(int &x, int &y, char *strLCDType);
	bool GetFirmWareVer();
	bool GetFlashID();
	bool GetFlashStatus();
	void WaitFlashReady();
	bool Erase4KFlash(ULONG Addr);
	bool FlashWREN();
	bool FlashWRSR(unsigned char status);
	bool WriteToFlash(char *srcData,int length,ULONG Addr);
	bool Flash_WR_Page(char *buff,long PacketLength,long addr);
	bool ReadFromFlash(char *DestData,int length,ULONG Addr);
	bool GetVerifyValue(unsigned char &x,unsigned char &y,ULONG lAddr,int iLength);
	bool SynchronizeDPFtime();
	BYTE uCWriteCMD;
	BYTE uCEraseCMD;
	BYTE uCReadCMD;
	ULONG	devID;
	bool bWriteByByte;
	char	typeName[32];
	unsigned short	memsize;
	BYTE myAckData[64];
	bool bWriteRSR;
private:
	CCommUSB *m_PtrCommUSB;
	bool SetOPCMD();
	int iFlashTypeCount;
	FLASH_TYPE_STRUCT *flashLib;
	void ReadFlashLib();
};

